SystemOrganization addCategory: #'Sudoku-Tenn2'!

BorderedMorph subclass: #Sudoku
	instanceVariableNames: 'sudokuGame sudokuMenu blocks menuTitles menuItems menuBlocks'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'Sudoku-Tenn2'!

!Sudoku commentStamp: 'DWT 1/15/2013 17:20:32.735' prior: 0!
Sudoku is a program to let you solve and make sudoku puzzles.

Instance Variables
	sudokuGame:		<Object>

sudokuGame
	- xxxxx
!

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 1/18/2013 17:46:44.947'!
fileNew: filename
	| stream gameValues emptyTest lockedState |
	
	gameValues:= 'This is the sudoku game ', filename, ' saved on: ',  Date today, '.', CR.
	
	1 to: 9 do: [:row| 
		
		1 to: 9 do: [:column| 
			emptyTest := (sudokuGame getGridCellValue: row column: column).
			lockedState:= (sudokuGame lockGridCell: row column: column).
			(emptyTest = '') 
				ifTrue:[gameValues:= gameValues, '0'] 
				ifFalse:[gameValues:= gameValues, emptyTest].
			(lockedState = true) 
				ifTrue:[gameValues:= gameValues, 't ']
				ifFalse:[gameValues:= gameValues, 'f ']			
			].
		gameValues := gameValues, CR
		].
	
			
	stream := FileStream forceNewFileNamed: (filename asString, '.sdk') asString. 

	stream 
	
	nextPutAll: gameValues asString;
	close.! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 1/24/2013 12:07:57.433'!
fileOpen: filename
	| stream  lineNumber cellValue lockState gameValues |
	"Doesn't work yet !!"
	
	gameValues:= Array new: 10.
	lineNumber:= 1.
	
	stream := FileStream readOnlyFileNamed: (filename asString, '.sdk'). 
	[stream atEnd] whileFalse: [
 		 | row |
		row := stream upTo: Character cr.
		gameValues at: lineNumber put: row.
		lineNumber:= lineNumber + 1.
	].
	stream close.

	2 to: 10 do: [ :rowNum |
		 1 to: 9 do: [ :columnNum |
					cellValue := (((gameValues at: rowNum) at: ((columnNum * 3)-2))) digitValue.
					lockState := ((gameValues at: rowNum) at: ((columnNum * 3)-1)) asString.
					
					"*** Strange behaviour: this next line doesn't put the values into the Sudoku game,
					but the line at the bottom which uses the same call, is able to put the right thing in ***"
					
					sudokuGame setGridCellValue: cellValue row: (rowNum-1) column: columnNum.
					"Transcript show: lockState asString, ' (' , (rowNum-1), ', ',  columnNum, ') '."
					(lockState = 't')
						ifTrue: [sudokuGame lockGridCell: true row: (rowNum-1) column: columnNum.]
						ifFalse: [sudokuGame lockGridCell: false row: (rowNum-1) column: columnNum]
		  ].
		"Transcript show: CR."
	].
! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 1/22/2013 16:54:09.457'!
fileOpenTesting: filename
"BROKEN ... can't seem to do a loop within stream, since it doesn't recognize stream inside the loop. Probably a scope problem. One solution is to stream into an array, and then close the stream and finally work on the array using a loop."
	| stream  gameValues copiedFileName cellValue lockState |
	"Doesn't work yet !!"
	
	"stream := FileStream readOnlyFileNamed: (filename asString) 

		do: [:rowNumber | 1 to: 10.    ""Each line is a row in Sudoku""
			(rowNumber > 1)			  ""skip title line""
				ifTrue: [gameValues := stream getLine
					do: [:columnNumber | 1 to: 9.
						cellValue := (gameValues at: ((columnNumber * 3)-2)).
						lockState := (gameValues at: ((columnNumber * 3)-1)).
						
						self setGridCellValue: cellValue row: (rowNumber-1) column: columnNumber.
						self lockGridCell: lockState row: rowNumber	 column: columnNumber.
					].
		
		stream nextLine. ].
	
	""test and see if we read the file correctly""	
	copiedFileName := filename , '_copied'.	
	stream := FileStream forceNewFileNamed: (copiedFileName asString).
	stream 
	nextPutAll: gameValues asString;
	close."
		
		
	"*** strange behaviour .. if all the Transcripts are combined into one line,
					the Transcript shows: UndefinedObject>>DoIt (dtSudoku is Undeclared) ***"
					
					"Transcript show: cellValue.
					Transcript show: '('.
					Transcript show: rowNum-1.
					Transcript show: ','.
					Transcript show: columnNum.
					Transcript show: '); '."
					"Transcript show: ' (', ', ', ' )', ' ;'."! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 1/24/2013 12:03:17.798'!
fileSave: filename
	| stream gameValues emptyTest lockedState |
	
	gameValues:= 'This is the sudoku game ', filename, ' saved on: ',  Date today, '.', CR.
	
	1 to: 9 do: [:row| 
		
		1 to: 9 do: [:column| 
			emptyTest := (sudokuGame getGridCellValue: row column: column).
			lockedState:= (sudokuGame lockGridCell: row column: column).
			(emptyTest = '') 
				ifTrue:[gameValues:= gameValues, '0'] 
				ifFalse:[gameValues:= gameValues, emptyTest].
			(lockedState = true) 
				ifTrue:[gameValues:= gameValues, 't ']
				ifFalse:[gameValues:= gameValues, 'f ']			
			].
		gameValues := gameValues, CR
		].
	
			
	stream := FileStream fileNamed: (filename asString, '.sdk') asString. 

	stream 
	
	nextPutAll: gameValues asString;
	close.! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 3/14/2013 11:01:04.662'!
initialize
	super initialize.
	self borderWidth: 0.
	self color: Color lightYellow.
	self extent: 9*(52.5@52.5).
	
	sudokuGame:= SudokuGrid new.
	self addMorph: sudokuGame.
	
	sudokuMenu := StandardFileMenu new.

"To add menuTitles simply add more with: statements"
	menuTitles := #('New' 'Open' 'Save' 'Create' 'Hint' 'Help' 'About' 'Quit').
	menuItems := menuTitles size.
	
	menuBlocks := Array new: menuItems.
	1 to:  menuItems do: [:itemNum |
		menuBlocks at: itemNum put: SudokuMenu new.
		self addMorph: (menuBlocks at: itemNum).
		(menuBlocks at: itemNum) position: 470@(20*(itemNum-1)).
		(menuBlocks at: itemNum) menuNum: (itemNum-1).
	]. 

	1 to: menuItems do: [:tileNum |
		(menuBlocks at: tileNum) tileTitle: (menuTitles at: tileNum)
	].sudokuMenu := StandardFileMenu new.

"To add menuTitles simply add more with: statements"
	menuTitles := #('New' 'Open' 'Save' 'Create' 'Hint' 'Help' 'About' 'Quit').
	menuItems := menuTitles size.
	
	menuBlocks := Array new: menuItems.
	1 to:  menuItems do: [:itemNum |
		menuBlocks at: itemNum put: SudokuMenu new.
		self addMorph: (menuBlocks at: itemNum).
		(menuBlocks at: itemNum) position: 470@(20*(itemNum-1)).
		(menuBlocks at: itemNum) menuNum: (itemNum-1).
	]. 

	1 to: menuItems do: [:tileNum |
		(menuBlocks at: tileNum) tileTitle: (menuTitles at: tileNum)
	].
	! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 3/7/2013 11:46:29.108'!
quitSudoku
	self delete.! !

BorderedMorph subclass: #SudokuBlock
	instanceVariableNames: 'values cell1 cell2 cell3 cell4 cell5 cell6 cell7 cell8 cell9 cellNumber cellObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 3/22/2012 15:30'!
addressToCellNumber: aRow and: aColumn

	( (aRow isInteger
		and: [aRow >= 1]
		and: [aRow < 4]) and:
		
		(aColumn isInteger
		and: [aColumn >= 1]
		and: [aColumn < 4]) )
		
	"ifTrue: [cellNumber:=  'cell', ((3*(aRow-1) + aColumn)) asString ] "
	"Insert BRUTE FORCE ..."
	ifTrue: [cellNumber:= 3*(aRow-1) + aColumn ]
! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/2/2012 12:29'!
availableValues
	^values   "This is an array of available numbers to put in the block"! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 6/21/2012 17:33'!
getCellValue: aRow and: aColumn
	| aCellValue |
	self addressToCellNumber: aRow and: aColumn.
			
			(cellNumber = 1) ifTrue: [aCellValue:= cell1 cellValue].
			(cellNumber = 2) ifTrue: [aCellValue:= cell2 cellValue].
			(cellNumber = 3) ifTrue: [aCellValue:= cell3 cellValue].
			(cellNumber = 4) ifTrue: [aCellValue:= cell4 cellValue].
			(cellNumber = 5) ifTrue: [aCellValue:= cell5 cellValue].
			(cellNumber = 6) ifTrue: [aCellValue:= cell6 cellValue].
			(cellNumber = 7) ifTrue: [aCellValue:= cell7 cellValue].
			(cellNumber = 8) ifTrue: [aCellValue:= cell8 cellValue].
			(cellNumber = 9) ifTrue: [aCellValue:= cell9 cellValue].
			
	^aCellValue.

			

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 4/19/2012 11:19'!
initialize
	super initialize.
	self	borderColor: Color red.
	self	borderWidth: 5.
	self 	extent: 3*(53@53).  "better to use extent property NOT 55@55"
	self	color: Color lightYellow.
	"values:= {1, 2, 3, 4, 5, 6, 7, 8, 9}. "      "these are all valid values in the block at init."
	"as they get used up just delete them, if they become unused, put them back in"
	
	"I'm sure there is a better way to do it, but I don't know how right now"
	cell1:= SudokuCell new.
	cell1 position: 0@0.
	self addMorph: cell1.
	cell2:= SudokuCell new.
	cell2 position: 52@0.
	self addMorph: cell2.
	cell3:= SudokuCell new.
	cell3 position: 104@0.
	self addMorph: cell3.
	
	cell4:= SudokuCell new.
	cell4 position: 0@52.
	self addMorph: cell4.
	cell5:= SudokuCell new.
	cell5 position: 52@52.
	self addMorph: cell5.
	cell6:= SudokuCell new.
	cell6 position: 104@52.
	self addMorph: cell6.
	
	cell7:= SudokuCell new.
	cell7 position: 0@104.
	self addMorph: cell7.
	cell8:= SudokuCell new.
	cell8 position: 52@104.
	self addMorph: cell8.
	cell9:= SudokuCell new.
	cell9 position: 104@104.
	self addMorph: cell9.
	
	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 1/16/2013 17:18:55.261'!
lockCell: aRow column: aColumn

	"^'addressToCellNumber: aRow and: aColumn' cellValue: aValue"
	self addressToCellNumber: aRow and: aColumn.	

			(cellNumber = 1) ifTrue: [^cell1 cellLock].
			(cellNumber = 2) ifTrue: [^cell2 cellLock].
			(cellNumber = 3) ifTrue: [^cell3 cellLock].
			(cellNumber = 4) ifTrue: [^cell4 cellLock].
			(cellNumber = 5) ifTrue: [^cell5 cellLock].
			(cellNumber = 6) ifTrue: [^cell6 cellLock].
			(cellNumber = 7) ifTrue: [^cell7 cellLock].
			(cellNumber = 8) ifTrue: [^cell8 cellLock].
			(cellNumber = 9) ifTrue: [^cell9 cellLock].
			
	

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 4/26/2012 08:07'!
lockCell: aBoolean row: aRow column: aColumn

	"^'addressToCellNumber: aRow and: aColumn' cellValue: aValue"
	self addressToCellNumber: aRow and: aColumn.
	(aBoolean isKindOf: Boolean)		
		ifTrue: [
			(cellNumber = 1) ifTrue: [cell1 cellLock: aBoolean].
			(cellNumber = 2) ifTrue: [cell2 cellLock: aBoolean].
			(cellNumber = 3) ifTrue: [cell3 cellLock: aBoolean].
			(cellNumber = 4) ifTrue: [cell4 cellLock: aBoolean].
			(cellNumber = 5) ifTrue: [cell5 cellLock: aBoolean].
			(cellNumber = 6) ifTrue: [cell6 cellLock: aBoolean].
			(cellNumber = 7) ifTrue: [cell7 cellLock: aBoolean].
			(cellNumber = 8) ifTrue: [cell8 cellLock: aBoolean].
			(cellNumber = 9) ifTrue: [cell9 cellLock: aBoolean].
			].
			
	

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/23/2012 09:21'!
reclaimAvailableValue: aNumber
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10])
		ifTrue: [ self changed].

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/23/2012 09:20'!
removeAvailableValue: aNumber
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10])
		ifTrue: [ self changed].

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 4/19/2012 16:03'!
setCellValue: aValue row: aRow column: aColumn
	"^'addressToCellNumber: aRow and: aColumn' cellValue: aValue"
	self addressToCellNumber: aRow and: aColumn.
	(aValue isInteger
		and: [aValue >= 0]
		and: [aValue < 10])
		
		ifTrue: [
			(cellNumber = 1) ifTrue: [cell1 cellValue: aValue].
			(cellNumber = 2) ifTrue: [cell2 cellValue: aValue].
			(cellNumber = 3) ifTrue: [cell3 cellValue: aValue].
			(cellNumber = 4) ifTrue: [cell4 cellValue: aValue].
			(cellNumber = 5) ifTrue: [cell5 cellValue: aValue].
			(cellNumber = 6) ifTrue: [cell6 cellValue: aValue].
			(cellNumber = 7) ifTrue: [cell7 cellValue: aValue].
			(cellNumber = 8) ifTrue: [cell8 cellValue: aValue].
			(cellNumber = 9) ifTrue: [cell9 cellValue: aValue].
			].
			
	

	! !

BorderedMorph subclass: #SudokuCell
	instanceVariableNames: 'cellValue cellRow cellColumn cellBlockNumber cellContents cellText cellLocked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellBlockNumber
	^cellBlockNumber.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:09'!
cellBlockNumber: aNumber
	"Set the block number value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellBlockNumber:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellColumn
	^cellColumn.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:10'!
cellColumn: aNumber
	"Set the column value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellColumn:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellLock
	^cellLocked.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/24/2013 11:20:05.305'!
cellLock: aBoolean
	"Set the lock to disable changing cellContents when cellValue is not 0" 
	
	"Squeak doesn't appear to know about isBoolean"
	((aBoolean isKindOf: Boolean) "and: (cellValue > 0)")      
		ifTrue: [cellLocked:= aBoolean.
			self changed.].

		
	"Note, SBE-183 says that isBoolean, isInteger kind of methods violate the principle of encapsulation, and that you should query the object instead ... no examples are given, and SBE is inconsistent in giving its code examples, since it uses this very feature."! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:12'!
cellRow
	^cellRow.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellRow: aNumber
	"Set the row value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellRow:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:12'!
cellValue
	^cellContents.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 4/19/2012 18:12'!
cellValue: aNumber
	"Set the shown number for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellValue:= aNumber.
			cellContents:= cellValue asString.
			self changed].
		(aNumber = 0and: [cellLocked = false]) 
		ifTrue: [cellContents:= ''.
			self changed].! !

!SudokuCell methodsFor: 'drawing' stamp: 'DWT 4/26/2012 09:18'!
drawOn:  aCanvas 
	super drawOn: aCanvas. 
		(self cellLock) ifTrue: [cellText color: Color red].
		(self cellLock) ifFalse: [cellText color: Color black].
		cellText contents: cellContents.

! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 4/19/2012 16:18'!
eraseCellValue
	"Set the shown number for the Sudoku cell."
	
	(cellLocked:= false)
		ifTrue: [cellContents:= ' ']
! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/26/2012 08:19'!
handleKeystroke: anEvent 
	| keyStroke |
	keyStroke:= anEvent keyValue.
	"ASCII 48 is the number 0, and ASCII 57 is the number 9"
	(keyStroke > 47 and: [keyStroke < 58])
		ifTrue: [self cellValue: (keyStroke-48)]. 
	"ASCII 108 is the letter l, for lock"
	(keyStroke = 108) ifTrue: [self cellLock: true].
	"ASCII 117 is the letter u, for unlock"
	(keyStroke = 117) ifTrue: [self cellLock: false].
	! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:29'!
handlesMouseOver: anEvent
	^true! !

!SudokuCell methodsFor: 'initialization' stamp: 'DWT 4/26/2012 09:19'!
initialize
	super initialize.
	self extent: 55@55.
	self borderWidth: 1.
	self borderColor: (Color blue alpha: 0.4).
	self color: Color lightYellow.
	cellContents := ''.
	cellLocked:= false.       "Use lock for generated suduko numbers in cell, use (bold)."
	cellRow:= 0.					  "Row, column and block number are defined when a new block is created"
	cellColumn:= 0.                 
	cellBlockNumber:=0.
	cellText:= StringMorph new contents: cellContents.
	self addMorph: (cellText
		center: self position + 0.5*(self extent))
		
	
"*** This was my first working bit, but I don't know how to communicate to it, so I thought it would be best to
try to instantiate an object, which then should be accesible:

self addMorph: ((StringMorph contents: cellContents)
		center: self position + 0.5*(self extent))"
		
"**************************************************************************"
		
"*** How to use TextMorph ... the problem here is that it also takes over the keyboard, and it doesn't seem to 
have any value to inspect: 

	cellText:= TextMorph new contents: cellContents.
	self addMorph: (cellText
		center: self position + 0.5*(self extent))"
	
	
	
	
	
	 ! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:55'!
mouseEnter: anEvent 
	anEvent hand newKeyboardFocus: self.
	self color: Color yellow.
	! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:55'!
mouseLeave: anEvent 
	anEvent hand newKeyboardFocus: nil.
	self color: Color lightYellow.! !

BorderedMorph subclass: #SudokuGrid
	instanceVariableNames: 'block1 block2 block3 block4 block5 block6 block7 block8 block9 blockNumber cellRow cellColumn cellNumber blocks sudokuMenu menuBlocks menuTitles menuItems quitSudouk quitSudoku rowGroup columnGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/14/2013 11:45:20.21'!
getGridCellValue:  aGridRow column: aGridColumn
	| aGridValue |
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
			aGridValue:= (blocks at: rowGroup at: columnGroup) getCellValue: cellRow and: cellColumn.
			Transcript show: aGridValue.
			^aGridValue.
		! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/14/2013 11:40:42.97'!
gridAddressToCellNumber: aGridRow and: aGridColumn
	"| rowGroup columnGroup |  keep these values"
	( (aGridRow isInteger
		and: [aGridRow >= 1]
		and: [aGridRow < 10]) and:
		
		(aGridColumn isInteger
		and: [aGridColumn >= 1]
		and: [aGridColumn < 10]) )
		
	"ifTrue: [gridCellNumber:=  'cell', ((3*(aGridRow-1) + aGridColumn)) asString ] "
	"Insert BRUTE FORCE ..."
	
	ifTrue: [ 
		((aGridRow >=1) and: [aGridRow < 4]) ifTrue: [rowGroup:= 1].
		((aGridRow >=4) and: [aGridRow < 7]) ifTrue: [rowGroup:= 2].
		((aGridRow >=7) and: [aGridRow < 10]) ifTrue: [rowGroup:= 3].
		
		((aGridColumn >=1) and: [aGridColumn < 4]) ifTrue: [columnGroup:= 1].
		((aGridColumn >=4) and: [aGridColumn < 7]) ifTrue: [columnGroup:= 2].
		((aGridColumn >=7) and: [aGridColumn < 10]) ifTrue: [columnGroup:= 3].
		
		blockNumber:=  3*(rowGroup-1) + columnGroup .
		
		cellRow:= aGridRow - (3*(rowGroup-1)).
		
		cellColumn:= aGridColumn - (3*(columnGroup-1)).
		
		cellNumber:= 3*(cellRow-1) + cellColumn.
		].
! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/14/2013 10:57:43.34'!
initialize
	super initialize.
	self 	extent: 9*(52.5@52.5).
	self	borderWidth: 1.
	self	color: Color lightYellow.
		
	blocks := Matrix new: 3.
	1 to: 3 do: [:rowNum |
		1 to: 3 do: [:colNum | | index |
			index := (rowNum-1)*3+colNum.
			blocks at: rowNum at: colNum put: SudokuBlock new.
			(blocks at: rowNum at: colNum) position: (156*(rowNum-1))@(156*(colNum-1)).
			self addMorph: (blocks at: rowNum at: colNum).
		].
	].
	! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 1/23/2013 14:15:53.415'!
lockGridCell: aGridRow column: aGridColumn
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
	
			(blockNumber = 1) ifTrue: [^block1 lockCell: cellRow column: cellColumn].
			(blockNumber = 2) ifTrue: [^block2 lockCell: cellRow column: cellColumn].
			(blockNumber = 3) ifTrue: [block3 lockCell: cellRow column: cellColumn].
			(blockNumber = 4) ifTrue: [block4 lockCell: cellRow column: cellColumn].
			(blockNumber = 5) ifTrue: [block5 lockCell: cellRow column: cellColumn].
			(blockNumber = 6) ifTrue: [block6 lockCell: cellRow column: cellColumn].
			(blockNumber = 7) ifTrue: [block7 lockCell: cellRow column: cellColumn].
			(blockNumber = 8) ifTrue: [block8 lockCell: cellRow column: cellColumn].
			(blockNumber = 9) ifTrue: [block9 lockCell: cellRow column: cellColumn].! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 1/23/2013 14:15:53.424'!
lockGridCell: aBoolean row: aGridRow column: aGridColumn
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
	(aBoolean isKindOf: Boolean)
			ifTrue: [
			(blockNumber = 1) ifTrue: [block1 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 2) ifTrue: [block2 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 3) ifTrue: [block3 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 4) ifTrue: [block4 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 5) ifTrue: [block5 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 6) ifTrue: [block6 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 7) ifTrue: [block7 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 8) ifTrue: [block8 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 9) ifTrue: [block9 lockCell: aBoolean row: cellRow column: cellColumn].
			].! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'Dt 2/28/2013 12:49'!
quitSudokuGrid
self delete! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 1/23/2013 14:15:53.434'!
setGridCellValue: aGridCellValue row: aGridRow column: aGridColumn
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
	(aGridCellValue isInteger
		and: [aGridCellValue >= 1]
		and: [aGridCellValue < 10])
		
			ifTrue: [
			(blockNumber = 1) ifTrue: [block1 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 2) ifTrue: [block2 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 3) ifTrue: [block3 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 4) ifTrue: [block4 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 5) ifTrue: [block5 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 6) ifTrue: [block6 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 7) ifTrue: [block7 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 8) ifTrue: [block8 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 9) ifTrue: [block9 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			].! !

BorderedMorph subclass: #SudokuMenu
	instanceVariableNames: 'cellValue cellRow cellColumn cellBlockNumber cellContents cellText cellLocked subMenuTitles subMenuItems subMenuBlocks menuNum aboutDialog help'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.887'!
cellBlockNumber
	^cellBlockNumber.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.893'!
cellBlockNumber: aNumber
	"Set the block number value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellBlockNumber:= aNumber.
			self changed].
! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.901'!
cellColumn
	^cellColumn.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.911'!
cellColumn: aNumber
	"Set the column value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellColumn:= aNumber.
			self changed].
! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.918'!
cellLock
	^cellLocked.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.924'!
cellLock: aBoolean
	"Set the lock to disable changing cellContents when cellValue is not 0" 
	
	"Squeak doesn't appear to know about isBoolean"
	((aBoolean isKindOf: Boolean) "and: (cellValue > 0)")      
		ifTrue: [cellLocked:= aBoolean.
			self changed.].

		
	"Note, SBE-183 says that isBoolean, isInteger kind of methods violate the principle of encapsulation, and that you should query the object instead ... no examples are given, and SBE is inconsistent in giving its code examples, since it uses this very feature."! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.931'!
cellRow
	^cellRow.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.937'!
cellRow: aNumber
	"Set the row value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellRow:= aNumber.
			self changed].
! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.944'!
cellValue
	^cellContents.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.95'!
cellValue: aNumber
	"Set the shown number for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellValue:= aNumber.
			cellContents:= cellValue asString.
			self changed].
		(aNumber = 0and: [cellLocked = false]) 
		ifTrue: [cellContents:= ''.
			self changed].! !

!SudokuMenu methodsFor: 'drawing' stamp: 'DWT 1/31/2013 19:53:53.964'!
drawOn:  aCanvas 
	super drawOn: aCanvas. 
		(self cellLock) ifTrue: [cellText color: Color red].
		(self cellLock) ifFalse: [cellText color: Color black].
		cellText contents: cellContents.

! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 19:53:53.958'!
eraseCellValue
	"Set the shown number for the Sudoku cell."
	
	(cellLocked:= false)
		ifTrue: [cellContents:= ' ']
! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 1/31/2013 19:53:53.979'!
handleKeystroke: anEvent 
	| keyStroke |
	keyStroke:= anEvent keyValue.
	"ASCII 48 is the number 0, and ASCII 57 is the number 9"
	(keyStroke > 47 and: [keyStroke < 58])
		ifTrue: [self cellValue: (keyStroke-48)]. 
	"ASCII 108 is the letter l, for lock"
	(keyStroke = 108) ifTrue: [self cellLock: true].
	"ASCII 117 is the letter u, for unlock"
	(keyStroke = 117) ifTrue: [self cellLock: false].
	! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 2/4/2013 18:48:29.12'!
handlesMouseDown: anEvent
	"^self type == #mouseDown"
	"Transcript show: 'Mouse is down'."
	^true.! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 1/31/2013 19:53:53.986'!
handlesMouseOver: anEvent
	^true! !

!SudokuMenu methodsFor: 'initialization' stamp: 'DWT 1/31/2013 20:20:57.615'!
initialize
	super initialize.
	self extent: 80@20.
	self borderWidth: 1.
	self borderColor: (Color red).
	self color: Color lightBlue.
	cellContents := ''.
	cellLocked:= false.       "Use lock for generated suduko numbers in cell, use (bold)."
	cellRow:= 0.					  "Row, column and block number are defined when a new block is created"
	cellColumn:= 0.                 
	cellBlockNumber:=0.
	cellText:= StringMorph new contents: cellContents.
	self addMorph: (cellText).
	cellText position: 4@0.
		
	
"*** This was my first working bit, but I don't know how to communicate to it, so I thought it would be best to
try to instantiate an object, which then should be accesible:

self addMorph: ((StringMorph contents: cellContents)
		center: self position + 0.5*(self extent))"
		
"**************************************************************************"
		
"*** How to use TextMorph ... the problem here is that it also takes over the keyboard, and it doesn't seem to 
have any value to inspect: 

	cellText:= TextMorph new contents: cellContents.
	self addMorph: (cellText
		center: self position + 0.5*(self extent))"
	
	
	
	
	
	 ! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 2/4/2013 19:33:22.119'!
menuNum
	"Set the the menu item number."
	^menuNum.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 2/4/2013 19:32:37.69'!
menuNum: aNumber
	"Set the the menu item number."
	menuNum := aNumber.! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 3/7/2013 11:42:58.57'!
mouseDown: anEvent 
	"To add menuTitles simply add more with: statements"
	(menuNum = 0) ifTrue:[Transcript show: '"New" not implimented yet.'; cr].
	(menuNum = 1) ifTrue:[Transcript show: '"Open" not implimented yet.'; cr].
	(menuNum = 2) ifTrue:[Transcript show: '"Save" not implimented yet.'; cr.
		super fileSave: 'testing'.].
	(menuNum = 3) ifTrue:[Transcript show: '"Create" not implimented yet.'; cr].
	(menuNum = 4) ifTrue:[Transcript show: '"Hint" not implimented yet.'; cr].
	(menuNum = 5) ifTrue:[Transcript show: '"Help" not implimented yet.'; cr.
		"help := Browser new.
		help
			rootTopic: 'Sudoku game help';
			openInWorld.
		self addMorph: help."
		].
	(menuNum = 6) ifTrue:[
		aboutDialog :=UserDialogBoxMorph new.
		aboutDialog 
			title: 'About Sudoku-Tenn2:';
			label: 'This program lets you play Sudoku, and create games, and store them. It also lets you save games in progress.';
			addButton: 'Quit' value: nil;
			"closeDialog: nil;"
			openInWorld.
		"self addMorph: aboutDialog. this is not too helpful!!"
		].
	"(menuNum = 7) ifTrue:[Transcript show: Quit not implimented yet.'; cr]."
	(menuNum = 7) ifTrue: [super quitSudoku].   
	" .... this doe NOT work!!"

	
! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 1/31/2013 20:03:59.984'!
mouseEnter: anEvent 
	anEvent hand newKeyboardFocus: self.
	self color: Color blue.
	! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 1/31/2013 20:05:25.563'!
mouseLeave: anEvent 
	anEvent hand newKeyboardFocus: nil.
	self color: Color lightBlue.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 2/4/2013 18:31:04.336'!
tileEvent: event
	"This is the mouse down action"
	^(event) asSymbol.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 1/31/2013 20:10:47.724'!
tileTitle: aString
	"Set the menu title"
	(aString isString)
		ifTrue: [ cellContents:= aString.
			self changed].! !
